Bug 738494

Summary: dracut failure on slightly odd kernel parameters
Product: [Fedora] Fedora Reporter: Mads Kiilerich <mads>
Component: dashAssignee: Huzaifa S. Sidhpurwala <huzaifas>
Status: CLOSED WONTFIX QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: unspecified Docs Contact:
Priority: unspecified    
Version: 16CC: davej, harald, huzaifas, jonathan, kay, maxim, mschmidt, psabata, zac
Target Milestone: ---   
Target Release: ---   
Hardware: Unspecified   
OS: Unspecified   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
: 744545 (view as bug list) Environment:
Last Closed: 2013-02-13 14:47:55 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Description Mads Kiilerich 2011-09-15 00:37:14 UTC
The introduction in the first lines of /usr/share/doc/kernel-doc-*/Documentation/kernel-parameters.txt gives a very strong indication that:

  Hyphens (dashes) and underscores are equivalent in parameter names, so
        log_buf_len=1M
  can also be entered as
        log-buf-len=1M

Adding the dashed version as a kernel parameter do however give 3 times "dracut Warning: Signal caught!" and a shell. There is _no_ indication what the problem is and it is impossible for mortals to debug it.

I assume this is a variation of the problem mentioned on https://bugzilla.redhat.com/show_bug.cgi?id=733674#c9

dracut-013-8.fc16

Comment 1 Michal Schmidt 2011-10-09 10:14:17 UTC
There are two bugs:

1) a kernel bug. It does not apply the dash-to-underscore conversion to early
   boot parameters. log_buf_len is an early parameter. As a consequence the
   string "log-buf-len=1M" gets passed in the environment to userspace.

2) a dash bug. dracut does:

   export -p > /tmp/export.orig
   # ...later:
   . /tmp/export.orig 2>/dev/null || :

   dash exits when it encounters the line "export log-buf-len=1M" in export.orig.
   Because "set -e" is not set, it should not not exit on error.

   Here's a small testcase:

     #!/bin/dash
     export foo-bar-baz=1
     sleep 5

   When run in dash, it reports an error and exits immediately. When run in bash,
   it works as expected - it reports an error and continues with the sleep.

Reassigning to dash. I'll make a clone BZ for the kernel bug.

Comment 2 Kay Sievers 2011-10-09 20:34:20 UTC
For the kernel and dracut side:
Nothing should rely on the fragile kernel environment variable export. The
kernel might suppress or mangle any parameter at any time.

Dracut should not export this to any file or tool, it should clean the
environment and force all tools to directly read /proc/cmdline. It's the
only safe option, everything else just asks for trouble, today and in
the future.

Please just get rid of this code snippet in dracut.

Comment 3 Zachary Bedell 2012-02-13 21:43:52 UTC
This issue is causing problems getting ZFS on Linux working with Grub in Dracut > 013.  Sun's standard for startup parameters is to pass 'zfs-bootfs' on the kernel command line from the boot loader.  With git commit ed42e64cfc2c3d36436ef0d0634332219dcce1a2 present, boot fails.  Removing this change allows the system to boot properly.

Comment 4 Harald Hoyer 2012-02-20 12:36:47 UTC
*** Bug 753950 has been marked as a duplicate of this bug. ***

Comment 5 Harald Hoyer 2012-02-20 12:38:06 UTC
proposed patch on list:

http://thread.gmane.org/gmane.comp.shells.dash/704

Comment 7 Fedora End Of Life 2013-01-16 13:52:54 UTC
This message is a reminder that Fedora 16 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 16. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '16'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 16's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 16 is end of life. If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora, you are encouraged to click on 
"Clone This Bug" and open it against that version of Fedora.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping

Comment 8 Fedora End Of Life 2013-02-13 14:47:59 UTC
Fedora 16 changed to end-of-life (EOL) status on 2013-02-12. Fedora 16 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.